.TH SHMCAT "1" "November 2012" "shmcat(1)"
.SH NAME
shmcat \- Shared-Memory-Segmente, Dateien, Standardeingabe und/oder Text ausgeben
.SH \(:UBERSICHT
.B shmcat [
.I OPTION
.B ]... [
.I OPERAND
.B ]...
.SH BESCHREIBUNG
Shared-Memory-Segmente, Dateien, die Standardeingabe und/oder Text auf der
Standardausgabe ausgeben. Wenn kein OPERAND angegeben wurde, wird nur
die Standardeingabe gelesen. Falls mehrere OPERANDen \(:ubergeben wurden, so
werden diese in der angegebenen Reihenfolge verarbeitet. Wenn einige der
OPERANDen nicht gelesen werden k\(:onnen, dann wird eine Fehlermeldung auf die
Standardfehlerausgabe geschrieben und mit den anderen OPERANDen fortgefahren.
.PP
Die meisten modernen Systeme unterst\(:utzen zwei APIs f\(:ur Shared-Memory:
.PP
Die \(:altere wird \(:ublicherweise als die System V API bezeichnet. Sie
verwendet numerische Schl\(:ussel und IDs als Bezeichner. Diese API besteht aus
Systemaufrufen wie \fBshmget(2)\fR, \fBshmat(2)\fR und \fBshmdt(2)\fR.
.PP
Die neuere API ist die POSIX Shared Memory API. Sie verwendet Namen in
Zeichenkettenform als Bezeichner. Sie behandelt Shared Memory \(:ahnlich wie
Dateien, die mittels \fBshm_open(3)\fR ge\(:offnet und dann \(:uber
\fBmmap(2)\fR in den Adressraum des aufrufenden Programms eingebunden werden.
Bitte beachten Sie, dass POSIX Shared Memory nicht von allen Versionen von
shmcat unterst\(:utzt wird.
.PP
Wenn shmcat ohne Unterst\(:utzung f\(:ur \fBgetopt_long(3)\fR kompiliert wurde,
dann k\(:onnen nur die kurzen, aus einem Buchstaben bestehenden OPTIONen und
OPERANDen verwendet werden. Ansonsten werden auch die langen Varianten
unterst\(:utzt. Wenn eine lange OPTION oder ein langer OPERAND ein Argument
ben\(:otigt, so gilt das auch f\(:ur die kurzen Varianten.
.SH OPTIONEN
.TP
\fB-h\fR, \fB-?\fR, \fB--help\fR
Informationen zur Verwendung des Programms anzeigen und ohne weitere
Ausgaben beenden.
.TP
\fB-V\fR, \fB--version\fR
Versionsinformationen anzeigen und ohne weitere Aktionen beenden.
.SH OPERANDEN
.TP
\fB-f\fR, \fB--file=\fIDATEINAME\fR
Den Inhalt der angegebenen Datei ausgeben.
.TP
\fB-i\fR, \fB--stdin\fR
Die Standardeingabe ausgeben.
.TP
\fB-M\fR, \fB--shmkey=\fISCHL\(:USSEL\fR
Das System-V-Shared-Memory-Segment mit dem \(:ubergebenen Schl\(:ussel ausgeben.
Der Schl\(:ussel kann als Dezimalzahl (ohne Pr\(:afix), Oktalzahl (mit einer
\fB0\fR als Pr\(:afix) oder Hexadezimalzahl (mit \fB0x\fR als Pr\(:afix)
\(:ubergeben werden. Man kann den Schl\(:ussel beispielsweise \(:uber eines
der Programme \fBipcs(1)\fR oder \fBftok(1)\fR erhalten.
.TP
\fB-m\fR, \fB--shmid=\fIID\fR
Das System-V-Shared-Memory-Segment mit der \(:ubergebenen ID ausgeben. Die ID
kann als Dezimalzahl (ohne Pr\(:afix), Oktalzahl (mit einer \fB0\fR als
Pr\(:afix) oder Hexadezimalzahl (mit \fB0x\fR als Pr\(:afix) \(:ubergeben
werden. Man kann die ID beispielsweise \(:uber das Kommando \fBipcs(1)\fR
erhalten.
.TP
\fB-n\fR, \fB--newline\fR
Einen Zeilenumbruch hinzuf\(:ugen.
.TP
\fB-p\fR, \fB--posix-shm=\fINAME\fR
Das POSIX-Shared-Memory-Segment mit dem angegebenen Namen ausgeben (nicht von
allen Installationen unterst\(:utzt).
.TP
\fB-t\fR, \fB--text=\fITEXT\fR
Den angegebenen Text ausgeben.
.SH R\(:UCKGABEWERTE
.TP
0
Kein Fehler, jeder gew\(:unschte OPERAND wurde ausgegeben
.TP
1
Es gab einen Fehler bei der Ausgabe von mindestens einem OPERANDen, aber das Programm konnte mit den anderen OPERANDen (falls angegeben) fortfahren
.TP
2
Es gab einen schwerwiegenden Fehler. Normalerweise bedeutet das, dass shmcat nicht auf die Standardausgabe schreiben konnte
.TP
10
Das Programm wurde falsch aufgerufen
.SH ANMERKUNGEN
Wenn Sie Shared-Memory-Segmente ausgeben m\(:ochten, sollten Sie normalerweise
die Ausgabe von shmcat in eine Datei oder zu einem Programm wie \fBod(1)\fR
umleiten, denn die Daten in einem Shared-Memory-Objekt haben \(:ublicherweise
ein bin\(:ares Format und k\(:onnen deshalb nicht-druckbare Zeichen enthalten.
Au\(sserdem sollten Sie die Prozesse anhalten, die in das Shared-Memory-Objekt
schreiben, um einen konsistenten Speicherabzug zu erhalten.
.SH AUTOR
Stefan Gast
.SH "SIEHE AUCH"
.BR ftok(1),
.BR ipcs(1),
.BR shmat(2),
.BR shmget(2),
.BR shm_open(3)
